﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// フラッシュを表すクラスです。
    /// </summary>
    class Flash
    {
        /// <summary>
        /// フラグ。
        /// </summary>
        public int flag;

        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// フラッシュの種類。
        /// </summary>
        public int knd;

        /// <summary>
        /// 何カウントで表現するか。
        /// </summary>
        public int to_cnt;

        /// <summary>
        /// 明るさ。
        /// </summary>
        public double brt;

        /// <summary>
        /// フラッシュを計算します。
        /// </summary>
        public void calc_flash()
        {
            if (this.flag > 0)
            {
                if (this.knd == 0) // 段々明るく、段々暗く
                {
                    if (this.cnt == 0)
                        this.brt = 0.0;

                    if (this.cnt < this.to_cnt)
                        this.brt += 255.0 / this.to_cnt;
                    else
                        this.brt -= 255.0 / this.to_cnt;
                }

                if (this.knd == 1) // フラッシュ
                {
                    if (this.cnt == 0)
                        this.brt = 255.0;

                    this.brt -= 255.0 / this.to_cnt;
                }

                this.cnt++;

                if (this.knd == 0)
                {
                    if (this.cnt > this.to_cnt * 2)
                        this.flag = 0;
                }
                if (this.knd == 1)
                {
                    if (this.cnt > this.to_cnt)
                        this.flag = 0;
                }
            }
        }
    }
}
