﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// ドン！と揺れる画面の情報を表すクラスです。
    /// </summary>
    class Dn
    {
        /// <summary>
        /// フラグ。
        /// </summary>
        public int flag;

        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// 時間。
        /// </summary>
        public int time;

        /// <summary>
        /// サイズ。
        /// </summary>
        public int size;

        /// <summary>
        /// X座標。
        /// </summary>
        public int x;

        /// <summary>
        /// Y座標。
        /// </summary>
        public int y;
        
        /// <summary>
        /// 初期化します。
        /// </summary>
        public void initialize()
        {
            this.flag = 0;
            this.cnt = 0;
            this.time = 0;
            this.size = 0;
            this.x = 0;
            this.y = 0;
        }

        /// <summary>
        /// ドン揺れを設定します。
        /// </summary>
        /// <param name="size">サイズ</param>
        /// <param name="time">タイム</param>
        public void enter_dn(int size, int time)
        {
            this.flag = 1;
            this.cnt = 0;
            this.size = size;
            this.time = time;
        }

        /// <summary>
        /// ドン揺れを計算します。
        /// </summary>
        public void dn_calc()
        {
            if (this.flag == 1)
            {
                this.x = (int)MyMath.rang(this.size);
                this.y = (int)MyMath.rang(this.size);
                this.cnt++;
                if (this.cnt > this.time) // 指定された時間がたつと終わる
                {
                    this.flag = 0;
                    this.x = 0;
                    this.y = 0;
                }
            }
        }
    }
}
